-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Html Editor - Overview
The HTML Editor component is a client-side WYSIWYG text editor. The editor allows users to format text and integrate media elements into documents. The result can be exported to HTML.
Users can edit and customize content using the toolbar that can contain predefined and custom controls. To specify the available controls, use the items array. In this demo, the toolbar contains predefined controls.
DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the HtmlEditor features used.
Backend API
$(() => {
const editor = $('.html-editor').dxHtmlEditor({
height: 725,
value: markup,
imageUpload: {
tabs: ['file', 'url'],
fileUploadMode: 'base64',
},
toolbar: {
items: [
'undo', 'redo', 'separator',
{
name: 'size',
acceptedValues: ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'],
options: { inputAttr: { 'aria-label': 'Font size' } },
},
{
name: 'font',
acceptedValues: ['Arial', 'Courier New', 'Georgia', 'Impact', 'Lucida Console', 'Tahoma', 'Times New Roman', 'Verdana'],
options: { inputAttr: { 'aria-label': 'Font family' } },
},
'separator', 'bold', 'italic', 'strike', 'underline', 'separator',
'alignLeft', 'alignCenter', 'alignRight', 'alignJustify', 'separator',
'orderedList', 'bulletList', 'separator',
{
name: 'header',
acceptedValues: [false, 1, 2, 3, 4, 5],
options: { inputAttr: { 'aria-label': 'Header' } },
}, 'separator',
'color', 'background', 'separator',
'link', 'image', 'separator',
'clear', 'codeBlock', 'blockquote', 'separator',
'insertTable', 'deleteTable',
'insertRowAbove', 'insertRowBelow', 'deleteRow',
'insertColumnLeft', 'insertColumnRight', 'deleteColumn',
],
},
mediaResizing: {
enabled: true,
},
}).dxHtmlEditor('instance');
$('#multiline').dxCheckBox({
text: 'Multiline toolbar',
value: true,
onValueChanged(e) {
editor.option('toolbar.multiline', e.value);
},
});
$('#image-uploader-tabs').dxSelectBox({
items: tabs,
value: tabs[2].value,
inputAttr: { 'aria-label': 'Tab' },
valueExpr: 'value',
displayExpr: 'name',
onValueChanged: (e) => {
editor.option('imageUpload.tabs', e.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/devextreme-quill@1.7.9/dist/dx-quill.min.js"></script>
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="html-editor"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div id="multiline"></div>
</div>
<div class="option">
<div class="label">Image upload tabs:</div>
<div id="image-uploader-tabs"></div>
</div>
</div>
</div>
</body>
</html>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.dx-htmleditor-content table {
width: 50%;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 40px;
}
.option > .dx-selectbox,
.option > .label {
display: inline-block;
vertical-align: middle;
}
.option > .label {
margin-right: 10px;
}
const tabs = [{ name: 'From This Device', value: ['file'] }, { name: 'From the Web', value: ['url'] }, { name: 'Both', value: ['file', 'url'] }];
const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML.</p>
<p>Supported features:</p>
<ul>
<li>Inline formats:
<ul>
<li><strong>Bold</strong>, <em>italic</em>, <s>strikethrough</s> text formatting</li>
<li>Font, size, color changes (HTML only)</li>
</ul>
</li>
<li>Block formats:
<ul>
<li>Headers</li>
<li>Text alignment</li>
<li>Lists (ordered and unordered)</li>
<li>Code blocks</li>
<li>Quotes</li>
</ul>
</li>
<li>Custom formats</li>
<li>Mail-merge placeholders (for example, %username%)</li>
<li>Adaptive toolbar for working images, links, and color formats</li>
<li>Image upload: drag-and-drop images onto the form, select files from the file system, or specify a URL.</li>
<li>Copy-paste rich content (unsupported formats are removed)</li>
<li>Tables support</li>
</ul>
<br>
<p>Supported frameworks and libraries</p>
<table>
<tr>
<td><strong>jQuery</strong></td>
<td style="text-align: right;">v2.1 - v2.2 and v3.x</td>
</tr>
<tr>
<td><strong>Angular</strong></td>
<td style="text-align: right;">v7.0+</td>
</tr>
<tr>
<td><strong>React</strong></td>
<td style="text-align: right;">v16.2+</td>
</tr>
<tr>
<td><strong>Vue</strong></td>
<td style="text-align: right;">v2.6.3+</td>
</tr>
</table>
`;
You can use the toolbar.multiline property to arrange the toolbar controls into multiple rows.
Users can resize media files when the mediaResizing is enabled. Currently, only images are supported.
To get started with the DevExtreme HTML Editor component, refer to the following tutorial for step-by-step instructions: Getting Started with HTML Editor.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the HtmlEditor features used.
Backend API
<template>
<div>
<DxHtmlEditor
:value="markup"
height="725px"
>
<DxMediaResizing :enabled="true"/>
<DxImageUpload
:tabs="currentTabs"
file-upload-mode="base64"
/>
<DxToolbar :multiline="isMultiline">
<DxItem name="undo"/>
<DxItem name="redo"/>
<DxItem name="separator"/>
<DxItem
name="size"
:accepted-values="sizeValues"
:options="fontSizeOptions"
/>
<DxItem
name="font"
:accepted-values="fontValues"
:options="fontFamilyOptions"
/>
<DxItem name="separator"/>
<DxItem name="bold"/>
<DxItem name="italic"/>
<DxItem name="strike"/>
<DxItem name="underline"/>
<DxItem name="separator"/>
<DxItem name="alignLeft"/>
<DxItem name="alignCenter"/>
<DxItem name="alignRight"/>
<DxItem name="alignJustify"/>
<DxItem name="separator"/>
<DxItem name="orderedList"/>
<DxItem name="bulletList"/>
<DxItem name="separator"/>
<DxItem
name="header"
:accepted-values="headerValues"
:options="headerOptions"
/>
<DxItem name="separator"/>
<DxItem name="color"/>
<DxItem name="background"/>
<DxItem name="separator"/>
<DxItem name="link"/>
<DxItem name="image"/>
<DxItem name="separator"/>
<DxItem name="clear"/>
<DxItem name="codeBlock"/>
<DxItem name="blockquote"/>
<DxItem name="separator"/>
<DxItem name="insertTable"/>
<DxItem name="deleteTable"/>
<DxItem name="insertRowAbove"/>
<DxItem name="insertRowBelow"/>
<DxItem name="deleteRow"/>
<DxItem name="insertColumnLeft"/>
<DxItem name="insertColumnRight"/>
<DxItem name="deleteColumn"/>
</DxToolbar>
</DxHtmlEditor>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="isMultiline"
text="Multiline toolbar"
/>
</div>
<div class="option">
<div class="label">Image upload tabs:</div>
<DxSelectBox
:items="tabs"
:input-attr="{ 'aria-label': 'Tab' }"
v-model:value="currentTabs"
display-expr="name"
value-expr="value"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxHtmlEditor,
DxToolbar,
DxMediaResizing,
DxImageUpload,
DxItem,
} from 'devextreme-vue/html-editor';
import {
DxCheckBox,
} from 'devextreme-vue/check-box';
import {
DxSelectBox,
} from 'devextreme-vue/select-box';
import { markup, tabs } from './data.ts';
const sizeValues = ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'];
const fontValues = ['Arial', 'Courier New', 'Georgia', 'Impact', 'Lucida Console', 'Tahoma', 'Times New Roman', 'Verdana'];
const headerValues = [false, 1, 2, 3, 4, 5];
const currentTabs = ref(tabs[2].value);
const isMultiline = ref(true);
const fontSizeOptions = { inputAttr: { 'aria-label': 'Font size' } };
const fontFamilyOptions = { inputAttr: { 'aria-label': 'Font family' } };
const headerOptions = { inputAttr: { 'aria-label': 'Font family' } };
</script>
<style>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.dx-htmleditor-content table {
width: 50%;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 40px;
}
.option > .dx-selectbox,
.option > .label {
display: inline-block;
vertical-align: middle;
}
.option > .label {
margin-right: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { type DxHtmlEditorTypes } from 'devextreme-vue/html-editor';
export const tabs: {
name: string,
value: DxHtmlEditorTypes.HtmlEditorImageUploadTab[]
}[] = [
{ name: 'From This Device', value: ['file'] },
{ name: 'From the Web', value: ['url'] },
{ name: 'Both', value: ['file', 'url'] },
];
export const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML.</p>
<p>Supported features:</p>
<ul>
<li>Inline formats:
<ul>
<li><strong>Bold</strong>, <em>italic</em>, <s>strikethrough</s> text formatting</li>
<li>Font, size, color changes (HTML only)</li>
</ul>
</li>
<li>Block formats:
<ul>
<li>Headers</li>
<li>Text alignment</li>
<li>Lists (ordered and unordered)</li>
<li>Code blocks</li>
<li>Quotes</li>
</ul>
</li>
<li>Custom formats</li>
<li>Mail-merge placeholders (for example, %username%)</li>
<li>Adaptive toolbar for working images, links, and color formats</li>
<li>Image upload: drag-and-drop images onto the form, select files from the file system, or specify a URL.</li>
<li>Copy-paste rich content (unsupported formats are removed)</li>
<li>Tables support</li>
</ul>
<br>
<p>Supported frameworks and libraries</p>
<table>
<tr>
<td><strong>jQuery</strong></td>
<td style="text-align: right;">v2.1 - v2.2 and v3.x</td>
</tr>
<tr>
<td><strong>Angular</strong></td>
<td style="text-align: right;">v7.0+</td>
</tr>
<tr>
<td><strong>React</strong></td>
<td style="text-align: right;">v16.2+</td>
</tr>
<tr>
<td><strong>Vue</strong></td>
<td style="text-align: right;">v2.6.3+</td>
</tr>
</table>
`;
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
You can use the toolbar.multiline property to arrange the toolbar controls into multiple rows.
Users can resize media files when the mediaResizing is enabled. Currently, only images are supported.
To get started with the DevExtreme HTML Editor component, refer to the following tutorial for step-by-step instructions: Getting Started with HTML Editor.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the HtmlEditor features used.
Backend API
<dx-html-editor height="725px" [value]="valueContent">
<dxo-html-editor-toolbar [multiline]="isMultiline">
<dxi-html-editor-item name="undo"></dxi-html-editor-item>
<dxi-html-editor-item name="redo"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item
name="size"
[acceptedValues]="['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt']"
[options]="{ inputAttr: { 'aria-label': 'Font size' } }"
></dxi-html-editor-item>
<dxi-html-editor-item
name="font"
[acceptedValues]="[
'Arial',
'Courier New',
'Georgia',
'Impact',
'Lucida Console',
'Tahoma',
'Times New Roman',
'Verdana'
]"
[options]="{ inputAttr: { 'aria-label': 'Font family' } }"
></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="bold"></dxi-html-editor-item>
<dxi-html-editor-item name="italic"></dxi-html-editor-item>
<dxi-html-editor-item name="strike"></dxi-html-editor-item>
<dxi-html-editor-item name="underline"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="alignLeft"></dxi-html-editor-item>
<dxi-html-editor-item name="alignCenter"></dxi-html-editor-item>
<dxi-html-editor-item name="alignRight"></dxi-html-editor-item>
<dxi-html-editor-item name="alignJustify"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="orderedList"></dxi-html-editor-item>
<dxi-html-editor-item name="bulletList"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item
name="header"
[acceptedValues]="[false, 1, 2, 3, 4, 5]"
[options]="{ inputAttr: { 'aria-label': 'Header' } }"
></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="color"></dxi-html-editor-item>
<dxi-html-editor-item name="background"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="link"></dxi-html-editor-item>
<dxi-html-editor-item name="image"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="clear"></dxi-html-editor-item>
<dxi-html-editor-item name="codeBlock"></dxi-html-editor-item>
<dxi-html-editor-item name="blockquote"></dxi-html-editor-item>
<dxi-html-editor-item name="separator"></dxi-html-editor-item>
<dxi-html-editor-item name="insertTable"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteTable"></dxi-html-editor-item>
<dxi-html-editor-item name="insertRowAbove"></dxi-html-editor-item>
<dxi-html-editor-item name="insertRowBelow"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteRow"></dxi-html-editor-item>
<dxi-html-editor-item name="insertColumnLeft"></dxi-html-editor-item>
<dxi-html-editor-item name="insertColumnRight"></dxi-html-editor-item>
<dxi-html-editor-item name="deleteColumn"></dxi-html-editor-item>
</dxo-html-editor-toolbar>
<dxo-html-editor-media-resizing [enabled]="true">
</dxo-html-editor-media-resizing>
<dxo-html-editor-image-upload [tabs]="currentTab" fileUploadMode="base64">
</dxo-html-editor-image-upload>
</dx-html-editor>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Multiline toolbar"
[(value)]="isMultiline"
></dx-check-box>
</div>
<div class="option">
<div class="label">Image upload tabs:</div>
<dx-select-box
[items]="tabs"
[inputAttr]="{ 'aria-label': 'Tab' }"
[(value)]="currentTab"
valueExpr="value"
displayExpr="name"
>
</dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxHtmlEditorModule, DxCheckBoxModule, DxSelectBoxModule } from 'devextreme-angular';
import { Service, TabConfig } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxHtmlEditorModule,
DxCheckBoxModule,
DxSelectBoxModule,
],
})
export class AppComponent {
isMultiline = true;
valueContent: string;
tabs: TabConfig[];
currentTab: string[];
constructor(service: Service) {
this.valueContent = service.getMarkup();
this.tabs = service.getTabsData();
this.currentTab = this.tabs[2].value;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
::ng-deep .dx-htmleditor-content table {
width: 50%;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 40px;
}
::ng-deep .option > .dx-selectbox,
::ng-deep .option > .label {
display: inline-block;
vertical-align: middle;
}
::ng-deep .option > .label {
margin-right: 10px;
}
import { Injectable } from '@angular/core';
export class TabConfig {
name: string;
value: string[];
}
const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML.</p>
<p>Supported features:</p>
<ul>
<li>Inline formats:
<ul>
<li><strong>Bold</strong>, <em>italic</em>, <s>strikethrough</s> text formatting</li>
<li>Font, size, color changes (HTML only)</li>
</ul>
</li>
<li>Block formats:
<ul>
<li>Headers</li>
<li>Text alignment</li>
<li>Lists (ordered and unordered)</li>
<li>Code blocks</li>
<li>Quotes</li>
</ul>
</li>
<li>Custom formats</li>
<li>Mail-merge placeholders (for example, %username%)</li>
<li>Adaptive toolbar for working images, links, and color formats</li>
<li>Image upload: drag-and-drop images onto the form, select files from the file system, or specify a URL.</li>
<li>Copy-paste rich content (unsupported formats are removed)</li>
<li>Tables support</li>
</ul>
<br>
<p>Supported frameworks and libraries</p>
<table>
<tr>
<td><strong>jQuery</strong></td>
<td style="text-align: right;">v2.1 - v2.2 and v3.x</td>
</tr>
<tr>
<td><strong>Angular</strong></td>
<td style="text-align: right;">v7.0+</td>
</tr>
<tr>
<td><strong>React</strong></td>
<td style="text-align: right;">v16.2+</td>
</tr>
<tr>
<td><strong>Vue</strong></td>
<td style="text-align: right;">v2.6.3+</td>
</tr>
</table>
`;
const tabsData: TabConfig[] = [
{ name: 'From This Device', value: ['file'] },
{ name: 'From the Web', value: ['url'] },
{ name: 'Both', value: ['file', 'url'] },
];
@Injectable()
export class Service {
getMarkup(): string {
return markup;
}
getTabsData(): TabConfig[] {
return tabsData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
You can use the toolbar.multiline property to arrange the toolbar controls into multiple rows.
Users can resize media files when the mediaResizing is enabled. Currently, only images are supported.
To get started with the DevExtreme HTML Editor component, refer to the following tutorial for step-by-step instructions: Getting Started with HTML Editor.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the HtmlEditor features used.
Backend API
import React, { useCallback, useState } from 'react';
import HtmlEditor, {
Toolbar,
MediaResizing,
ImageUpload,
Item,
} from 'devextreme-react/html-editor';
import CheckBox, { type CheckBoxTypes } from 'devextreme-react/check-box';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import { markup, tabs, tabLabel } from './data.ts';
const sizeValues = ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'];
const fontValues = [
'Arial',
'Courier New',
'Georgia',
'Impact',
'Lucida Console',
'Tahoma',
'Times New Roman',
'Verdana',
];
const headerValues = [false, 1, 2, 3, 4, 5];
const fontSizeOptions = {
inputAttr: {
'aria-label': 'Font size',
},
};
const fontFamilyOptions = {
inputAttr: {
'aria-label': 'Font family',
},
};
const headerOptions = {
inputAttr: {
'aria-label': 'Font family',
},
};
export default function App() {
const [isMultiline, setIsMultiline] = useState(true);
const [currentTab, setCurrentTab] = useState(tabs[2].value);
const multilineChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => {
setIsMultiline(e.value);
}, [setIsMultiline]);
const currentTabChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
setCurrentTab(e.value);
}, [setCurrentTab]);
return (
<div className="widget-container">
<HtmlEditor height="725px" defaultValue={markup}>
<MediaResizing enabled={true} />
<ImageUpload tabs={currentTab} fileUploadMode="base64" />
<Toolbar multiline={isMultiline}>
<Item name="undo" />
<Item name="redo" />
<Item name="separator" />
<Item name="size" acceptedValues={sizeValues} options={fontSizeOptions} />
<Item name="font" acceptedValues={fontValues} options={fontFamilyOptions} />
<Item name="separator" />
<Item name="bold" />
<Item name="italic" />
<Item name="strike" />
<Item name="underline" />
<Item name="separator" />
<Item name="alignLeft" />
<Item name="alignCenter" />
<Item name="alignRight" />
<Item name="alignJustify" />
<Item name="separator" />
<Item name="orderedList" />
<Item name="bulletList" />
<Item name="separator" />
<Item name="header" acceptedValues={headerValues} options={headerOptions} />
<Item name="separator" />
<Item name="color" />
<Item name="background" />
<Item name="separator" />
<Item name="link" />
<Item name="image" />
<Item name="separator" />
<Item name="clear" />
<Item name="codeBlock" />
<Item name="blockquote" />
<Item name="separator" />
<Item name="insertTable" />
<Item name="deleteTable" />
<Item name="insertRowAbove" />
<Item name="insertRowBelow" />
<Item name="deleteRow" />
<Item name="insertColumnLeft" />
<Item name="insertColumnRight" />
<Item name="deleteColumn" />
</Toolbar>
</HtmlEditor>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Multiline toolbar"
value={isMultiline}
onValueChanged={multilineChanged}
/>
</div>
<div className="option">
<div className="label">Image upload tabs:</div>
<SelectBox
items={tabs}
value={currentTab}
valueExpr="value"
inputAttr={tabLabel}
displayExpr="name"
onValueChanged={currentTabChanged}
/>
</div>
</div>
</div>
);
}
import React, { useCallback, useState } from 'react';
import HtmlEditor, {
Toolbar,
MediaResizing,
ImageUpload,
Item,
} from 'devextreme-react/html-editor';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import { markup, tabs, tabLabel } from './data.js';
const sizeValues = ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'];
const fontValues = [
'Arial',
'Courier New',
'Georgia',
'Impact',
'Lucida Console',
'Tahoma',
'Times New Roman',
'Verdana',
];
const headerValues = [false, 1, 2, 3, 4, 5];
const fontSizeOptions = {
inputAttr: {
'aria-label': 'Font size',
},
};
const fontFamilyOptions = {
inputAttr: {
'aria-label': 'Font family',
},
};
const headerOptions = {
inputAttr: {
'aria-label': 'Font family',
},
};
export default function App() {
const [isMultiline, setIsMultiline] = useState(true);
const [currentTab, setCurrentTab] = useState(tabs[2].value);
const multilineChanged = useCallback(
(e) => {
setIsMultiline(e.value);
},
[setIsMultiline],
);
const currentTabChanged = useCallback(
(e) => {
setCurrentTab(e.value);
},
[setCurrentTab],
);
return (
<div className="widget-container">
<HtmlEditor
height="725px"
defaultValue={markup}
>
<MediaResizing enabled={true} />
<ImageUpload
tabs={currentTab}
fileUploadMode="base64"
/>
<Toolbar multiline={isMultiline}>
<Item name="undo" />
<Item name="redo" />
<Item name="separator" />
<Item
name="size"
acceptedValues={sizeValues}
options={fontSizeOptions}
/>
<Item
name="font"
acceptedValues={fontValues}
options={fontFamilyOptions}
/>
<Item name="separator" />
<Item name="bold" />
<Item name="italic" />
<Item name="strike" />
<Item name="underline" />
<Item name="separator" />
<Item name="alignLeft" />
<Item name="alignCenter" />
<Item name="alignRight" />
<Item name="alignJustify" />
<Item name="separator" />
<Item name="orderedList" />
<Item name="bulletList" />
<Item name="separator" />
<Item
name="header"
acceptedValues={headerValues}
options={headerOptions}
/>
<Item name="separator" />
<Item name="color" />
<Item name="background" />
<Item name="separator" />
<Item name="link" />
<Item name="image" />
<Item name="separator" />
<Item name="clear" />
<Item name="codeBlock" />
<Item name="blockquote" />
<Item name="separator" />
<Item name="insertTable" />
<Item name="deleteTable" />
<Item name="insertRowAbove" />
<Item name="insertRowBelow" />
<Item name="deleteRow" />
<Item name="insertColumnLeft" />
<Item name="insertColumnRight" />
<Item name="deleteColumn" />
</Toolbar>
</HtmlEditor>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Multiline toolbar"
value={isMultiline}
onValueChanged={multilineChanged}
/>
</div>
<div className="option">
<div className="label">Image upload tabs:</div>
<SelectBox
items={tabs}
value={currentTab}
valueExpr="value"
inputAttr={tabLabel}
displayExpr="name"
onValueChanged={currentTabChanged}
/>
</div>
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export interface Tab {
name: string,
value: ('file' | 'url')[],
}
export const tabs: Tab[] = [
{ name: 'From This Device', value: ['file'] },
{ name: 'From the Web', value: ['url'] },
{ name: 'Both', value: ['file', 'url'] },
];
export const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML.</p>
<p>Supported features:</p>
<ul>
<li>Inline formats:
<ul>
<li><strong>Bold</strong>, <em>italic</em>, <s>strikethrough</s> text formatting</li>
<li>Font, size, color changes (HTML only)</li>
</ul>
</li>
<li>Block formats:
<ul>
<li>Headers</li>
<li>Text alignment</li>
<li>Lists (ordered and unordered)</li>
<li>Code blocks</li>
<li>Quotes</li>
</ul>
</li>
<li>Custom formats</li>
<li>Mail-merge placeholders (for example, %username%)</li>
<li>Adaptive toolbar for working images, links, and color formats</li>
<li>Image upload: drag-and-drop images onto the form, select files from the file system, or specify a URL.</li>
<li>Copy-paste rich content (unsupported formats are removed)</li>
<li>Tables support</li>
</ul>
<br>
<p>Supported frameworks and libraries</p>
<table>
<tr>
<td><strong>jQuery</strong></td>
<td style="text-align: right;">v2.1 - v2.2 and v3.x</td>
</tr>
<tr>
<td><strong>Angular</strong></td>
<td style="text-align: right;">v7.0+</td>
</tr>
<tr>
<td><strong>React</strong></td>
<td style="text-align: right;">v16.2+</td>
</tr>
<tr>
<td><strong>Vue</strong></td>
<td style="text-align: right;">v2.6.3+</td>
</tr>
</table>
`;
export const tabLabel = { 'aria-label': 'Tab' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const tabs = [
{ name: 'From This Device', value: ['file'] },
{ name: 'From the Web', value: ['url'] },
{ name: 'Both', value: ['file', 'url'] },
];
export const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML.</p>
<p>Supported features:</p>
<ul>
<li>Inline formats:
<ul>
<li><strong>Bold</strong>, <em>italic</em>, <s>strikethrough</s> text formatting</li>
<li>Font, size, color changes (HTML only)</li>
</ul>
</li>
<li>Block formats:
<ul>
<li>Headers</li>
<li>Text alignment</li>
<li>Lists (ordered and unordered)</li>
<li>Code blocks</li>
<li>Quotes</li>
</ul>
</li>
<li>Custom formats</li>
<li>Mail-merge placeholders (for example, %username%)</li>
<li>Adaptive toolbar for working images, links, and color formats</li>
<li>Image upload: drag-and-drop images onto the form, select files from the file system, or specify a URL.</li>
<li>Copy-paste rich content (unsupported formats are removed)</li>
<li>Tables support</li>
</ul>
<br>
<p>Supported frameworks and libraries</p>
<table>
<tr>
<td><strong>jQuery</strong></td>
<td style="text-align: right;">v2.1 - v2.2 and v3.x</td>
</tr>
<tr>
<td><strong>Angular</strong></td>
<td style="text-align: right;">v7.0+</td>
</tr>
<tr>
<td><strong>React</strong></td>
<td style="text-align: right;">v16.2+</td>
</tr>
<tr>
<td><strong>Vue</strong></td>
<td style="text-align: right;">v2.6.3+</td>
</tr>
</table>
`;
export const tabLabel = { 'aria-label': 'Tab' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.dx-htmleditor-content table {
width: 50%;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 40px;
}
.option > .dx-selectbox,
.option > .label {
display: inline-block;
vertical-align: middle;
}
.option > .label {
margin-right: 10px;
}
You can use the toolbar.multiline property to arrange the toolbar controls into multiple rows.
Users can resize media files when the mediaResizing is enabled. Currently, only images are supported.
To get started with the DevExtreme HTML Editor component, refer to the following tutorial for step-by-step instructions: Getting Started with HTML Editor.